#include <PololuMaestro.h>

#ifdef SERIAL_PORT_HARDWARE_OPEN
  #define maestroSerial SERIAL_PORT_HARDWARE_OPEN
#else
  #include <SoftwareSerial.h>
  SoftwareSerial maestroSerial(10, 11);
#endif

MiniMaestro maestro(maestroSerial); 
  

int sameScreen;
int16_t width = 24;

uint8_t grid[24];

//The new grid is used so that 'grid' is not compromised
uint8_t oldgrid[24];
boolean rungrid = 0; 
int mysteps = 0; 

int mode = 0; 

// set up the 24 servos
int startangle = 6000; 
int endangle = 4000;
char *myServo[24] = {"0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23"};


void setup() {
  maestroSerial.begin(9600); // Set the serial baud rate.
  
  Serial.begin(9600); //use only for debugging purposes
    initGrid();
  for (int16_t x = 0; x < width; x++) {
    Serial.print(grid[x]);
    maestro.setSpeed(myServo, 10);
    maestro.setAcceleration(myServo, 0);
  
  }
  resetServo();
}


void loop() { 

   if (mysteps < 100) {
    delay(200);
    computeCA();
    delay(200);
    drawGrid();
    delay(200);
    setServo();

    delay(4000);     
 } 
  mysteps++;
}

//Draws the grid on the display
void drawGrid(void) {
 for (int16_t x = 0; x < width; x++) {
    Serial.print(grid[x]);
 }
  Serial.println(' ');
  Serial.flush();
}

//Initialize Grid
void initGrid(void) {
  for (int16_t x = -1; x < width; x++) {
    // alternate colors
      // alternate colors
      uint8_t color = random(2);
      grid[x] = color;
      Serial.println(color); 
  }
Serial.flush();
}


//Compute the CA. Basically everything related to CA starts here
void computeCA() {
    for (int8_t x = -1; x < width; x++) {
      oldgrid[x] = grid[x]; 
    }
  for (int8_t x = 0; x < width-1; x++) {
    uint8_t xminus = oldgrid[x-1];
    uint8_t xplus = oldgrid[x+1];
    uint8_t newvalue = xminus ^ xplus; 
   
    grid[x] = newvalue; 
  }
}

void resetServo() {
  
    for (int8_t x = -1; x < width; x++) {
       if (mode == 1) {
         void setTarget(unsigned char myServo, unsigned int startangle);{
            const int deviceId = 0x0C; //controller ID 12
            const int startByte = 0xAA; // Protocol selection
            const int targetCmd = 0x04; // Command ID
         }
         Serial.print(x);
         Serial.print(" ");
         Serial.println(startangle);
         }
    }
    Serial.flush();
}


void setServo() {

  for (int8_t x =0; x < width; x++) {
    if(grid[x] == 1) {
      if (mode == 1) {
          void setTarget(unsigned char myServo, unsigned int endangle); {
            const int deviceId = 0x0C; //controller ID 12
            const int startByte = 0xAA; // Protocol selection
            const int targetCmd = 0x04; // Command ID
            }
          }
      Serial.print(x);
      Serial.print(" ");
      Serial.println(endangle);
     }    
    
    if(grid[x] == 0) {
      if (mode == 1) {
         void setTarget(unsigned char myServo, unsigned int startangle); {
            const int deviceId = 0x0C; //controller ID 12
            const int startByte = 0xAA; // Protocol selection
            const int targetCmd = 0x04; // Command ID
            }
           }
       Serial.print(x);
       Serial.print(" ");
       Serial.println(startangle);
     }
  }
}
